/*  логика игры - начало */

// объект -- состояние игры
var gameState = {
    gamer1Name: '', // игрок 1
    gamer2Name: '', // игрок 2
    whichTurn: '',  // чей ход
    hody: [],       // массив сделанных ходов (gameState.hody.lenght)
    hodyX: [],      // ходы крестиков - очищается при переходе хода
    hodyXOk: [],    // все ходы крестиков в течение игры
    hody0: [],      // ходы ноликов - очищается при переходе хода
    hody0Ok: [],    // все ходы ноликов в течение игры
    hodyOk: []
};

// функции -- начало

//// функция выполняющаяся при завершении игры
function stopGame() {
    // здесь выполняется код по клику в кнопку "Закончить игру"

    stopBtn.addClass('hide'); // скрываем кнопку "закончить игру"
    startBtn.removeClass('hide'); // показываем кнопку "начать игру"
    startBtn.attr('disabled', 'disabled'); // блокируем кнопку "начать игру"

    // включаем сообщение "Игра завершена"
    $('#m1').removeClass('hide');
    $('#m2').addClass('hide');

    // ждём 10 секунд и...
    setTimeout(function () {
        // возвращаем сообщение m3
        $('#m1').addClass('hide');
        $('#m3').removeClass('hide');
        $('#gamer-1').val('');
        $('#gamer-2').val('');
    }, 10000);

    // сбрасываем состояние игры
    gameState = {
        gamer1Name: '', // игрок 1
        gamer2Name: '', // игрок 2
        whichTurn: '', // чей ход
        hody: [],       // массив сделанных ходов (gameState.hody.lenght)
        hodyX: [],      // ходы крестиков - очищается при переходе хода
        hodyXOk: [],    // все ходы крестиков в течение игры
        hody0: [],      // ходы ноликов - очищается при переходе хода
        hody0Ok: [],    // все ходы ноликов в течение игры
        hodyOk: []
    };

    // дебаг
    //console.log("GameState:", gameState);
}

function validateGamers() {
    gameState.gamer1Name = $('#gamer-1').val();
    gameState.gamer2Name = $('#gamer-2').val();
    if((gameState.gamer1Name.length>0) && (gameState.gamer2Name.length>0)){
        startBtn.removeAttr('disabled'); // разблокируем кнопку
    } else {
        startBtn.attr('disabled', 'disabled'); // блокируем кнопку
    }
}

// обновление информации о игроке
function updateTurnInfo() {

    if (gameState.whichTurn!==''){

        var prefixText = 'Ход игрока ';

        if(gameState.whichTurn===1){
            $('#m2-text').html(prefixText + gameState.gamer1Name);
        } else if(gameState.whichTurn===2){
            $('#m2-text').html(prefixText + gameState.gamer2Name);
        }

    }

}

function setCellState(selector, state){

    var validSelectors = ["a1", "a2", "a3", "b1", "b2", "b3", "c1", "c2", "c3"];

    if(validSelectors.indexOf(selector) === -1){
        var err = new Error("Введён недопустимый селектор");
        throw err;
    }

    var validStates = ["X", "0", "-1"];

    if(validStates.indexOf(state) === -1){
        var err = new Error("Введён недопустимое состояние");
        throw err;
    }

    // определяем имя класса в зависимости от state
    var cellClass;
    switch (state) {
        case "X":
            cellClass = "krestik";
            break;
        case "0":
            cellClass = "nolik";
            break;
        case "-1":
            cellClass = "default";
            break;
    }

    // если состояние -1 то переменной state присвоить &nbsp;
    if(state === "-1"){
        state = '&nbsp;';
    }

   // console.log('ходы X до:', gameState.hodyX);
   // console.log('ходы 0 до', gameState.hody0);
   // console.log('все ходы до:', gameState.hody);

    if( cellClass === "krestik"
        && gameState.whichTurn===1
        && gameState.hodyX.length === 0
        && gameState.hodyOk.indexOf(selector) === -1){

        if(gameState.hodyX.indexOf(selector) === -1){
            gameState.hodyX = gameState.hodyX.concat(selector);
            gameState.hodyXOk = gameState.hodyXOk.concat(selector);
        }

        if(gameState.hody.indexOf(selector) === -1){
            gameState.hody = gameState.hody.concat(selector);
        }

        // отобрать элемент разметки
        var section = $('#'+selector);

        // поместить внутрь тега состояние
        section.html(state);
        section.removeClass('krestik');
        section.removeClass('nolik');
        section.removeClass('default');
        section.addClass(cellClass);

    }

    else if(cellClass === "nolik" && gameState.whichTurn===2 && gameState.hody0.length === 0 && gameState.hodyOk.indexOf(selector) === -1){
        if(gameState.hody0.indexOf(selector) === -1){
            gameState.hody0 = gameState.hody0.concat(selector);
            gameState.hody0Ok = gameState.hody0Ok.concat(selector);
        }
        if(gameState.hody.indexOf(selector) === -1){
            gameState.hody = gameState.hody.concat(selector);
        }

        // отобрать элемент разметки
        var section = $('#'+selector);

        // поместить внутрь тега состояние
        section.html(state);
        section.removeClass('krestik');
        section.removeClass('nolik');
        section.removeClass('default');
        section.addClass(cellClass);
    }

    if(cellClass === "default"){

        gameState.hodyX.splice(gameState.hodyX.indexOf(selector),1);
        gameState.hody0.splice(gameState.hody0.indexOf(selector),1);
        gameState.hody.splice(gameState.hody.indexOf(selector),1);

        // отобрать элемент разметки
        var section = $('#'+selector);

        // поместить внутрь тега состояние
        section.html(state);
        section.removeClass('krestik');
        section.removeClass('nolik');
        section.removeClass('default');
        section.addClass(cellClass);

    }

    //console.log('ходы X после:', gameState.hodyX);
    //console.log('ходы 0 после', gameState.hody0);
    //console.log('все ходы после:', gameState.hody);

}


function userClick(clickedElementId) {

    if (gameState.whichTurn !== 1 && gameState.whichTurn !== 2) {
        alert('Игра не начата. Нажмите кнопку "Начать игру!"');
        return false;
    }

    var clickedCell = $('#' + clickedElementId);

    if (clickedCell.hasClass('default')) {
        if (gameState.whichTurn === 1) {
            setCellState(clickedElementId, "X");
        } else if (gameState.whichTurn === 2) {
            setCellState(clickedElementId, "0");
        }
    } else if (clickedCell.hasClass('krestik')) {
        if (gameState.whichTurn === 1) {
            setCellState(clickedElementId, "-1");
        }
        // var clickedCell = document.getElementById(clickedElementId);
        //
        // switch (clickedCell.className) {
        //     case 'default':
        //         if(gameState.whichTurn === 1){
        //             setCellState(clickedElementId, "X");
        //         } else if (gameState.whichTurn === 2){
        //             setCellState(clickedElementId, "0");
        //         }
        //         break;
        //     case 'krestik':
        //         if(gameState.whichTurn === 1){
        //             setCellState(clickedElementId, "-1");
        //         }
        //         break;
        //     case 'nolik':
        //         if(gameState.whichTurn === 2){
        //             setCellState(clickedElementId, "-1");
        //         }
        //         break;
        // }
    } else if (clickedCell.hasClass('nolik')) {
        if (gameState.whichTurn === 2) {
            setCellState(clickedElementId, "-1");
        }
    }

    checkWinner();

    // активируем кнопку "сделать ход"
    $("#go").removeAttr('disabled');

    return true;
}

// функция проверки победителя - вызывается при клике в любую клетку игрового поля
function checkWinner() {

    var winnerNotFound = true;

    // поиск победителя (диагональ снизу слева вверх вправо)
    winnerNotFound = winnerNotFound && !(gameState.hody0Ok.indexOf("a3") !== -1 && gameState.hody0Ok.indexOf("b2") !== -1 && gameState.hody0Ok.indexOf("c1") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hody0Ok.indexOf("a1") !== -1 && gameState.hody0Ok.indexOf("b2") !== -1 && gameState.hody0Ok.indexOf("c3") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hody0Ok.indexOf("b1") !== -1 && gameState.hody0Ok.indexOf("b2") !== -1 && gameState.hody0Ok.indexOf("b3") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hody0Ok.indexOf("a2") !== -1 && gameState.hody0Ok.indexOf("b2") !== -1 && gameState.hody0Ok.indexOf("c2") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hody0Ok.indexOf("a1") !== -1 && gameState.hody0Ok.indexOf("a2") !== -1 && gameState.hody0Ok.indexOf("a3") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hody0Ok.indexOf("c1") !== -1 && gameState.hody0Ok.indexOf("c2") !== -1 && gameState.hody0Ok.indexOf("c3") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hody0Ok.indexOf("a1") !== -1 && gameState.hody0Ok.indexOf("b1") !== -1 && gameState.hody0Ok.indexOf("c1") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hody0Ok.indexOf("a3") !== -1 && gameState.hody0Ok.indexOf("b3") !== -1 && gameState.hody0Ok.indexOf("c3") !== -1);

    winnerNotFound = winnerNotFound && !(gameState.hodyXOk.indexOf("a3") !== -1 && gameState.hodyXOk.indexOf("b2") !== -1 && gameState.hodyXOk.indexOf("c1") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hodyXOk.indexOf("a1") !== -1 && gameState.hodyXOk.indexOf("b2") !== -1 && gameState.hodyXOk.indexOf("c3") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hodyXOk.indexOf("b1") !== -1 && gameState.hodyXOk.indexOf("b2") !== -1 && gameState.hodyXOk.indexOf("b3") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hodyXOk.indexOf("a2") !== -1 && gameState.hodyXOk.indexOf("b2") !== -1 && gameState.hodyXOk.indexOf("c2") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hodyXOk.indexOf("a1") !== -1 && gameState.hodyXOk.indexOf("a2") !== -1 && gameState.hodyXOk.indexOf("a3") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hodyXOk.indexOf("c1") !== -1 && gameState.hodyXOk.indexOf("c2") !== -1 && gameState.hodyXOk.indexOf("c3") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hodyXOk.indexOf("a1") !== -1 && gameState.hodyXOk.indexOf("b1") !== -1 && gameState.hodyXOk.indexOf("c1") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hodyXOk.indexOf("a3") !== -1 && gameState.hodyXOk.indexOf("b3") !== -1 && gameState.hodyXOk.indexOf("c3") !== -1);


    if(!winnerNotFound){

        // определяем имя победителя
        var winnerName = (gameState.whichTurn === 1) ? gameState.gamer1Name : gameState.gamer2Name;

        // записать результаты в локальное хранилище браузера
        storeResult(gameState);

        // остановить игру
        stopGame();
        // определить победителя

        setTimeout(function () {
            alert('Игра окончена. Победитель: ' + winnerName);
        }, 500);

    }

}

function storeResult(gameState) {

    var d = new Date;

    var rec={
        winner: '',
        loser: '',
        xOr0: '',
        dateStr: d.getDate()+'.'+(d.getMonth()+1)+'.'+d.getFullYear()+' '+d.getHours()+':'+d.getMinutes()+':'+d.getSeconds()
    };

    switch (gameState.whichTurn) {
        case 1:
            rec.winner = gameState.gamer1Name;
            rec.loser = gameState.gamer2Name;
            rec.xOr0 = 'X';
            break;
        case 2:
            rec.winner = gameState.gamer2Name;
            rec.loser = gameState.gamer1Name;
            rec.xOr0 = '0';
            break;
    }

    // прочитать историю игр из браузера

    var history = localStorage.getItem('gameHistory');

    if(null === history){
        history = [];
    } else {
        history = JSON.parse(history);
    }

    history = history.concat(rec);

    localStorage.setItem('gameHistory', JSON.stringify(history));

}

// функции -- конец

    var startBtn = $('#start-game');
    var stopBtn = $('#stop-game');
    var goBtn = $('#go');

// слушаем клик на кнопке "Начать игру" и выполняем коллбэк
    startBtn.click(function () {
        // здесь выполняется код по клику в кнопку "Начать игру"
        //console.log('gameState: ', gameState);

        gameState.hodyOk.length = 0;

        //stopBtn.addClass('hide'); // скрываем эту кнопку
        $(this).addClass('hide'); // скрываем эту кнопку
        stopBtn.removeClass('hide'); // показываем кнопку "закончить игру"

        // включаем сообщение "Идёт игра"
        $('#m2').removeClass('hide');
        $('#m3').addClass('hide');

        // определяем рандомно кто ходит
        gameState.whichTurn = Math.floor(Math.random() * 2) + 1;

        updateTurnInfo();


    });


// слушаем клик на кнопке "Закончить игру" и выполняем коллбэк
    stopBtn.click(function () {
        stopGame();
    });

// слушаем клик на кнопке "Сделать ход" и переключаем игрока
    goBtn.click(function () {

    });

// слушаем события отпускания клавиши на полях ввода имён игроков
// дз: реализовать то же самое на чистом js
    $('#gamer-1,#gamer-2').keyup(function () {
        validateGamers();
    });

// слушаем события клика в любую игровую ячейку
    $('#a1,#a2,#a3,#b1,#b2,#b3,#c1,#c2,#c3').click(function () {
        var el = $(this).attr('id');
        userClick(el);
    });

// слушаем события клика в кнопку "сделать ход"
    $('#go').click(function () {

        // коллбэк по нажатию кнопки - переключить игрока
        //gameState.whichTurn = 2;

        // если ход игрока 1, то очистить массив gameState.hodyX
        if(gameState.whichTurn === 1){
            gameState.hodyX.length=0;
        }

        // если ход игрока 2, то очистить массив gameState.hody0
        if(gameState.whichTurn === 2){
            gameState.hody0.length=0;
        }

        // v1 (условная конструкция - классический вариант)
        // if(gameState.whichTurn === 1) {
        //     gameState.whichTurn = 2;
        // } else (gameState.whichTurn === 2){
        //     gameState.whichTurn = 1;
        // }

        // v2 (условная конструкция - тернарный вариант)
        gameState.whichTurn = (gameState.whichTurn === 1) ? 2 : 1;

        gameState.hody.forEach(function (hod) {
            // если текущих ход отсутствует в коллекции gameState.hodyOk
            if(gameState.hodyOk.indexOf(hod) === -1){
                // то добавляем его
                gameState.hodyOk = gameState.hodyOk.concat(hod);
            }
        });

        // блокируем кнопку "сделать ход"
        $("#go").attr('disabled', 'disabled');

        updateTurnInfo();

        // отладка
        //console.log('hodyOK', gameState.hodyOk);
    });

    // $('#debug').click(function () {
    //   storeResult(gameState);
    // });
