/*  логика игры - начало */

// объект -- состояние игры
var gameState = {
  gamer1Name: '', // игрок 1
  gamer2Name: '', // игрок 2
  whichTurn: '',  // чей ход
  hody: [],       // массив сделанных ходов (gameState.hody.lenght)
  hodyX: [],      // ходы крестиков - очищается при переходе хода
  hodyXOk: [],    // все ходы крестиков в течение игры
  hody0: [],      // ходы ноликов - очищается при переходе хода
  hody0Ok: [],    // все ходы ноликов в течение игры
  hodyOk: []
};

var startBtn = document.getElementById('start-game');
var stopBtn = document.getElementById('stop-game');
var goBtn = document.getElementById('go');

// слушаем клик на кнопке "Начать игру" и выполняем коллбэк
startBtn.addEventListener("click", function () {
    // здесь выполняется код по клику в кнопку "Начать игру"

    console.log('gameState: ', gameState);

    gameState.hodyOk.length = 0;

    // заблокировать эту кнопку
    startBtn.setAttribute("disabled", "disabled");

    // включаем сообщение
    document.getElementById('message').classList.remove('hidden');

    // разблокировать кнопку "Закончить игру"
    stopBtn.removeAttribute("disabled");

    // заносим игроков в объект состояния игры
    gameState.gamer1Name = document.getElementById('gamer-1').value;
    gameState.gamer2Name = document.getElementById('gamer-2').value;

    // и даём первому игроку делать ход
    gameState.whichTurn = 1;

    // дебаг
    console.log("GameState:", gameState);
});

// слушаем клик на кнопке "Закончить игру" и выполняем коллбэк

function stopGame() {
    // здесь выполняется код по клику в кнопку "Закончить игру"

    // заблокировать эту кнопку
    stopBtn.setAttribute("disabled", "disabled");

    // разблокировать кнопку "Начать игру"
    startBtn.removeAttribute("disabled");

    // выключаем сообщение
    document.getElementById('message').classList.add('hidden');

    // сбрасываем состояние игры
    gameState = {
        gamer1Name: '', // игрок 1
        gamer2Name: '', // игрок 2
        whichTurn: '', // чей ход
        hody: [],       // массив сделанных ходов (gameState.hody.lenght)
        hodyX: [],      // ходы крестиков - очищается при переходе хода
        hodyXOk: [],    // все ходы крестиков в течение игры
        hody0: [],      // ходы ноликов - очищается при переходе хода
        hody0Ok: [],    // все ходы ноликов в течение игры
        hodyOk: []
    };

    // дебаг
    console.log("GameState:", gameState);
}

stopBtn.addEventListener("click", stopGame);

// слушаем клик на кнопке "Сделать ход" и переключаем игрока
goBtn.addEventListener("click", function () {
    // коллбэк по нажатию кнопки - переключить игрока
    //gameState.whichTurn = 2;

    // v1
    // if(gameState.whichTurn === 1) {
    //     gameState.whichTurn = 2;
    // } else (gameState.whichTurn === 2){
    //     gameState.whichTurn = 1;
    // }

    // если ход игрока 1, то очистить массив gameState.hodyX
    if(gameState.whichTurn === 1){
        gameState.hodyX.length=0;
    }

    // если ход игрока 2, то очистить массив gameState.hody0
    if(gameState.whichTurn === 2){
        gameState.hody0.length=0;
    }

    // v2
    gameState.whichTurn = (gameState.whichTurn === 1) ? 2 : 1;

    //gameState.hodyOk = gameState.hodyOk.concat(gameState.hody);

    gameState.hody.forEach(function (hod) {
       if(gameState.hodyOk.indexOf(hod) === -1){
           gameState.hodyOk = gameState.hodyOk.concat(hod);
       }
    });

    console.log('hodyOK', gameState.hodyOk);


});

/*  логика игры - конец */

// функция переключения состояния ячейки
function setCellState(selector, state){

    var validSelectors = ["a1", "a2", "a3", "b1", "b2", "b3", "c1", "c2", "c3"];

    if(validSelectors.indexOf(selector) === -1){
        var err = new Error("Введён недопустимый селектор");
        throw err;
    }

    var validStates = ["X", "0", "-1"];

    if(validStates.indexOf(state) === -1){
        var err = new Error("Введён недопустимое состояние");
        throw err;
    }

    // определяем имя класса в зависимости от state
    var cellClass;
    switch (state) {
        case "X":
            cellClass = "krestik";
            break;
        case "0":
            cellClass = "nolik";
            break;
        case "-1":
            cellClass = "default";
            break;
    }

    // если состояние -1 то переменной state присвоить &nbsp;
    if(state === "-1"){
        state = '&nbsp;';
    }

    console.log('ходы X до:', gameState.hodyX);
    console.log('ходы 0 до', gameState.hody0);
    console.log('все ходы до:', gameState.hody);

    if(cellClass === "krestik" && gameState.whichTurn===1 && gameState.hodyX.length === 0 && gameState.hodyOk.indexOf(selector) === -1){
        if(gameState.hodyX.indexOf(selector) === -1){
            gameState.hodyX = gameState.hodyX.concat(selector);
            gameState.hodyXOk = gameState.hodyXOk.concat(selector);
        }
        if(gameState.hody.indexOf(selector) === -1){
            gameState.hody = gameState.hody.concat(selector);
        }

        // отобрать элемент разметки
        var section = document.getElementById(selector);

        // поместить внутрь тега состояние
        section.innerHTML = state;
        section.className = cellClass;

    }

    else if(cellClass === "nolik" && gameState.whichTurn===2 && gameState.hody0.length === 0 && gameState.hodyOk.indexOf(selector) === -1){
        if(gameState.hody0.indexOf(selector) === -1){
            gameState.hody0 = gameState.hody0.concat(selector);
            gameState.hody0Ok = gameState.hody0Ok.concat(selector);
        }
        if(gameState.hody.indexOf(selector) === -1){
            gameState.hody = gameState.hody.concat(selector);
        }

        // отобрать элемент разметки
        var section = document.getElementById(selector);

        // поместить внутрь тега состояние
        section.innerHTML = state;
        section.className = cellClass;
    }

    if(cellClass === "default"){

        gameState.hodyX.splice(gameState.hodyX.indexOf(selector),1);
        gameState.hody0.splice(gameState.hody0.indexOf(selector),1);
        gameState.hody.splice(gameState.hody.indexOf(selector),1);

        // отобрать элемент разметки
        var section = document.getElementById(selector);

        // поместить внутрь тега состояние
        section.innerHTML = state;
        section.className = cellClass;

    }

    /*if(
        (gameState.whichTurn===1 && gameState.hodyX.length <= 1 && gameState.hody.indexOf(selector) === -1)
        || (gameState.whichTurn===2 && gameState.hody0.length <= 1 && gameState.hody.indexOf(selector) === -1)
    ){
        // отобрать элемент разметки
        var section = document.getElementById(selector);

        // поместить внутрь тега состояние
        section.innerHTML = state;
        section.className = cellClass;
    }*/


    /*switch (state) {
        case "X":
            if(gameState.hodyX.indexOf(selector) === -1){
                gameState.hodyX = gameState.hodyX.concat(selector);
            }
            if(gameState.hody.indexOf(selector) === -1){
                gameState.hody = gameState.hody.concat(selector);
            }
            break;
        case "0":
            if(gameState.hody0.indexOf(selector) === -1){
                gameState.hody0 = gameState.hody0.concat(selector);
            }
            if(gameState.hody.indexOf(selector) === -1){
                gameState.hody = gameState.hody.concat(selector);
            }
            break;
        case "&nbsp;":
            gameState.hodyX.shift(selector);
            gameState.hody0.shift(selector);
            gameState.hody.shift(selector);
            break;
    }

    console.log('hodyX', gameState.hodyX);
    console.log('hody0', gameState.hody0);
    console.log('gameState.hody:', gameState.hody);*/

    console.log('ходы X после:', gameState.hodyX);
    console.log('ходы 0 после', gameState.hody0);
    console.log('все ходы после:', gameState.hody);

}

function userClick(clickedElement) {
   // console.log("Юзер кликнул", clickedElement);

    if(gameState.whichTurn !== 1 && gameState.whichTurn !== 2){
        alert('Игра не начата. Нажмите кнопку "Начать игру!"');
    }

    var clickedCell = document.getElementById(clickedElement);

    switch (clickedCell.className) {
        case 'default':
            if(gameState.whichTurn === 1){
                setCellState(clickedElement, "X");
            } else if (gameState.whichTurn === 2){
                setCellState(clickedElement, "0");
            }
            break;
        case 'krestik':
            if(gameState.whichTurn === 1){
                setCellState(clickedElement, "-1");
            }
            break;
        case 'nolik':
            if(gameState.whichTurn === 2){
                setCellState(clickedElement, "-1");
            }
            break;
    }

    checkWinner();
}

// функция проверки победителя - вызывается при клике в любую клетку игрового поля
function checkWinner() {

    var winnerNotFound = true;

    // поиск победителя (диагональ снизу слева вверх вправо)
    winnerNotFound = winnerNotFound && !(gameState.hodyXOk.indexOf("a3") !== -1 && gameState.hodyXOk.indexOf("b2") !== -1 && gameState.hodyXOk.indexOf("c1") !== -1);
    winnerNotFound = winnerNotFound && !(gameState.hody0Ok.indexOf("a3") !== -1 && gameState.hody0Ok.indexOf("b2") !== -1 && gameState.hody0Ok.indexOf("c1") !== -1);


    if(!winnerNotFound){

        // определяем имя победителя
        var winnerName = (gameState.whichTurn === 1) ? gameState.gamer1Name : gameState.gamer2Name;

        // остановить игру
        stopGame();
        // определить победителя

        setTimeout(function () {
            alert('Игра окончена. Победитель: ' + winnerName);
        }, 500);

    }

}

// формируем массив из селекторов для отбора элементов разметки и добавления к ним слушателей
// события click
var selectors = ["a1", "a2", "a3", "b1", "b2", "b3", "c1", "c2", "c3"];

selectors.forEach(function (el) {
   // для каждого селектора из массива слушаем событие click и вызываем коллбэк userClick();
    var currentCell = document.getElementById(el);
    currentCell.addEventListener("click", function () {
        userClick(el);
    }); // важно коллбэк передавать без скобок!
                                                      // т.к. это не вызов функции, а передача
                                                      // названия функции коллбэку
    // (подразумевается, что коллбэк сам вызовет эту функцию, когда наступит событие click)
});



function debug() {
  // console.log(gameState.hody.indexOf("a1"));


    //console.log(gameState.hodyX, gameState.hody0);


}